/*-------------------------------------------------------------------------+
| Copyright 2015 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.dse.backend.opt4j.create;

import org.fortiss.af3.exploration.alg.dse.backend.opt4j.encoding.ArchitectureExplorationEncoding;
import org.fortiss.af3.exploration.alg.dse.backend.opt4j.extensions.compositegene.create.CompositeCreatorBase;
import org.fortiss.af3.exploration.alg.dse.backend.opt4j.extensions.compositegene.genotype.ComposableGenotype;
import org.fortiss.af3.exploration.alg.dse.sysmodel.arch.SystemModelAdapter;
import org.fortiss.af3.exploration.moea.model.DseSpecification;
import org.opt4j.core.problem.Creator;

import com.google.inject.Inject;

/**
 * {@link Creator} of the {@link ArchitectureExplorationEncoding} of an architectural exploration
 * problem, that consists of sub encodings. Refer to {@link ComposableGenotype} for further
 * documentation.
 * 
 * @author diewald
 */
public class ArchitectureExplorationCreator extends
		CompositeCreatorBase<ArchitectureExplorationEncoding> {

	/** DSE specification */
	protected DseSpecification dse;

	/** Constructor. */
	@Inject
	public ArchitectureExplorationCreator(DseSpecification dse,
			SystemModelAdapter<?, ?, ?, ?, ?, ?> systemModelAdapter) {
		super(systemModelAdapter);
		this.dse = dse;
	}

	/** {@inheritDoc} */
	@Override
	public ArchitectureExplorationEncoding createComposite() {
		return new ArchitectureExplorationEncoding();
	}
}
