/*-------------------------------------------------------------------------+
| Copyright 2015 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.dse.backend.opt4j.encoding.taskmapping.abstractmapping;

import org.fortiss.af3.exploration.alg.dse.backend.opt4j.encoding.partitionmapping.Partition;
import org.fortiss.af3.exploration.alg.dse.backend.opt4j.encoding.taskmapping.TaskMappingEntry;
import org.fortiss.af3.exploration.alg.dse.sysmodel.arch.IDeployableComponentAdapter;

/**
 * {@link TaskMappingEntry} whose referenced {@link IDeployableComponentAdapter} may require
 * initialization to derive a "valid" mapping.
 * 
 * @author diewald
 */
public class AbstractTaskMappingEntry
		extends TaskMappingEntry<IDeployableComponentAdapter<?>, Partition> implements Cloneable {

	/** Constructs a mapping entry the represents the mapping to a given deployment target. */
	public AbstractTaskMappingEntry(IDeployableComponentAdapter<?> deployableComponent,
			Partition deploymentTarget) {
		super(deployableComponent, deploymentTarget);
	}

	/** {@inheritDoc} */
	@Override
	public AbstractTaskMappingEntry clone() {
		return new AbstractTaskMappingEntry(getSource(), getTarget());
	}

	/** {@inheritDoc} */
	@Override
	public String toString() {
		return getTarget().getName();
	}
}
