/*-------------------------------------------------------------------------+
| Copyright 2015 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.dse.backend.opt4j.solution;

import org.fortiss.af3.exploration.alg.dse.backend.opt4j.extensions.compositegene.phenotype.Phenotype;
import org.fortiss.af3.exploration.alg.dse.sysmodel.mapping.IMappingEntry;
import org.fortiss.af3.exploration.alg.service.IExplorationEncoding;

/**
 * Interface allowing external access to schedules that are a solution or part of a solution of a
 * DSE run for a defined problem.
 * 
 * @author diewald
 */
public interface IScheduleSolution<P extends Phenotype> extends IExplorationEncoding {

	/**
	 * Returns the {@link TimeSlot} that has been reserved for the given {@link IMappingEntry}.
	 * Returns null, if no {@link TimeSlot} could be found.
	 */
	public TimeSlot getTimeSlotOf(IMappingEntry entry);
}
